## mdocml 1.14.5

=== Makefile ===
# $Id: Makefile,v 1.530 2019/03/06 16:08:41 schwarze Exp $
#
# Copyright (c) 2010, 2011, 2012 Kristaps Dzonsons <kristaps@bsd.lv>
# Copyright (c) 2011, 2013-2019 Ingo Schwarze <schwarze@openbsd.org>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

VERSION = 1.14.5

# === LIST OF FILES ====================================================

TESTSRCS	 = test-be32toh.c \
		   test-cmsg.c \
		   test-dirent-namlen.c \
		   test-EFTYPE.c \
		   test-err.c \
		   test-fts.c \
		   test-getline.c \
		   test-getsubopt.c \
		   test-isblank.c \
		   test-mkdtemp.c \
		   test-nanosleep.c \
		   test-noop.c \
		   test-ntohl.c \
		   test-O_DIRECTORY.c \
		   test-ohash.c \
		   test-PATH_MAX.c \
		   test-pledge.c \
		   test-progname.c \
		   test-reallocarray.c \
		   test-recallocarray.c \
		   test-recvmsg.c \
		   test-rewb-bsd.c \
		   test-rewb-sysv.c \
		   test-sandbox_init.c \
		   test-strcasestr.c \
		   test-stringlist.c \
		   test-strlcat.c \
		   test-strlcpy.c \
		   test-strndup.c \
		   test-strptime.c \
		   test-strsep.c \
		   test-strtonum.c \
		   test-vasprintf.c \
		   test-wchar.c

SRCS		 = arch.c \
		   att.c \
		   catman.c \
		   cgi.c \
		   chars.c \
		   compat_err.c \
		   compat_fts.c \
		   compat_getline.c \
		   compat_getsubopt.c \
		   compat_isblank.c \
		   compat_mkdtemp.c \
		   compat_ohash.c \
		   compat_progname.c \
		   compat_reallocarray.c \
		   compat_recallocarray.c \
		   compat_strcasestr.c \
		   compat_stringlist.c \
		   compat_strlcat.c \
		   compat_strlcpy.c \
		   compat_strndup.c \
		   compat_strsep.c \
		   compat_strtonum.c \
		   compat_vasprintf.c \
		   dba.c \
		   dba_array.c \
		   dba_read.c \
		   dba_write.c \
		   dbm.c \
		   dbm_map.c \
		   demandoc.c \
		   eqn.c \
		   eqn_html.c \
		   eqn_term.c \
		   html.c \
		   lib.c \
		   main.c \
		   man.c \
		   man_html.c \
		   man_macro.c \
		   man_term.c \
		   man_validate.c \
		   mandoc.c \
		   mandoc_aux.c \
		   mandoc_msg.c \
		   mandoc_ohash.c \
		   mandoc_xr.c \
		   mandocd.c \
		   mandocdb.c \
		   manpath.c \
		   mansearch.c \
		   mdoc.c \
		   mdoc_argv.c \
		   mdoc_html.c \
		   mdoc_macro.c \
		   mdoc_man.c \
		   mdoc_markdown.c \
		   mdoc_state.c \
		   mdoc_term.c \
		   mdoc_validate.c \
		   msec.c \
		   out.c \
		   preconv.c \
		   read.c \
		   roff.c \
		   roff_html.c \
		   roff_term.c \
		   roff_validate.c \
		   soelim.c \
		   st.c \
		   tag.c \
		   tbl.c \
		   tbl_data.c \
		   tbl_html.c \
		   tbl_layout.c \
		   tbl_opts.c \
		   tbl_term.c \
		   term.c \
		   term_ascii.c \
		   term_ps.c \
		   term_tab.c \
		   tree.c

DISTFILES	 = INSTALL \
		   LICENSE \
		   Makefile \
		   Makefile.depend \
		   NEWS \
		   TODO \
		   apropos.1 \
		   catman.8 \
		   cgi.h.example \
		   compat_fts.h \
		   compat_ohash.h \
		   compat_stringlist.h \
		   configure \
		   configure.local.example \
		   dba.h \
		   dba_array.h \
		   dba_write.h \
		   dbm.h \
		   dbm_map.h \
		   demandoc.1 \
		   eqn.7 \
		   eqn.h \
		   eqn_parse.h \
		   gmdiff \
		   html.h \
		   lib.in \
		   libman.h \
		   libmandoc.h \
		   libmdoc.h \
		   main.h \
		   makewhatis.8 \
		   man.1 \
		   man.7 \
		   man.cgi.3 \
		   man.cgi.8 \
		   man.conf.5 \
		   man.h \
		   man.options.1 \
		   manconf.h \
		   mandoc.1 \
		   mandoc.3 \
		   mandoc.css \
		   mandoc.db.5 \
		   mandoc.h \
		   mandoc_aux.h \
		   mandoc_char.7 \
		   mandoc_escape.3 \
		   mandoc_headers.3 \
		   mandoc_html.3 \
		   mandoc_malloc.3 \
		   mandoc_ohash.h \
		   mandoc_parse.h \
		   mandoc_xr.h \
		   mandocd.8 \
		   mansearch.3 \
		   mansearch.h \
		   mchars_alloc.3 \
		   mdoc.7 \
		   mdoc.h \
		   msec.in \
		   out.h \
		   predefs.in \
		   roff.7 \
		   roff.h \
		   roff_int.h \
		   soelim.1 \
		   tag.h \
		   tbl.3 \
		   tbl.7 \
		   tbl.h \
		   tbl_int.h \
		   tbl_parse.h \
		   term.h \
		   $(SRCS) \
		   $(TESTSRCS)

LIBMAN_OBJS	 = man.o \
		   man_macro.o \
		   man_validate.o

LIBMDOC_OBJS	 = att.o \
		   lib.o \
		   mdoc.o \
		   mdoc_argv.o \
		   mdoc_macro.o \
		   mdoc_state.o \
		   mdoc_validate.o \
		   st.o

LIBROFF_OBJS	 = eqn.o \
		   roff.o \
		   roff_validate.o \
		   tbl.o \
		   tbl_data.o \
		   tbl_layout.o \
		   tbl_opts.o

LIBMANDOC_OBJS	 = $(LIBMAN_OBJS) \
		   $(LIBMDOC_OBJS) \
		   $(LIBROFF_OBJS) \
		   arch.o \
		   chars.o \
		   mandoc.o \
		   mandoc_aux.o \
		   mandoc_msg.o \
		   mandoc_ohash.o \
		   mandoc_xr.o \
		   msec.o \
		   preconv.o \
		   read.o

COMPAT_OBJS	 = compat_err.o \
		   compat_fts.o \
		   compat_getline.o \
		   compat_getsubopt.o \
		   compat_isblank.o \
		   compat_mkdtemp.o \
		   compat_ohash.o \
		   compat_progname.o \
		   compat_reallocarray.o \
		   compat_recallocarray.o \
		   compat_strcasestr.o \
		   compat_strlcat.o \
		   compat_strlcpy.o \
		   compat_strndup.o \
		   compat_strsep.o \
		   compat_strtonum.o \
		   compat_vasprintf.o

MANDOC_HTML_OBJS = eqn_html.o \
		   html.o \
		   man_html.o \
		   mdoc_html.o \
		   roff_html.o \
		   tbl_html.o

MANDOC_TERM_OBJS = eqn_term.o \
		   man_term.o \
		   mdoc_term.o \
		   roff_term.o \
		   term.o \
		   term_ascii.o \
		   term_ps.o \
		   term_tab.o \
		   tbl_term.o

DBM_OBJS	 = dbm.o \
		   dbm_map.o \
		   mansearch.o

DBA_OBJS	 = dba.o \
		   dba_array.o \
		   dba_read.o \
		   dba_write.o \
		   mandocdb.o

MAIN_OBJS	 = $(MANDOC_HTML_OBJS) \
		   $(MANDOC_MAN_OBJS) \
		   $(MANDOC_TERM_OBJS) \
		   $(DBM_OBJS) \
		   $(DBA_OBJS) \
		   main.o \
		   manpath.o \
		   mdoc_man.o \
		   mdoc_markdown.o \
		   out.o \
		   tag.o \
		   tree.o

CGI_OBJS	 = $(MANDOC_HTML_OBJS) \
		   $(DBM_OBJS) \
		   cgi.o \
		   out.o

MANDOCD_OBJS	 = $(MANDOC_HTML_OBJS) \
		   $(MANDOC_TERM_OBJS) \
		   mandocd.o \
		   out.o \
		   tag.o

DEMANDOC_OBJS	 = demandoc.o

SOELIM_OBJS	 = soelim.o \
		   compat_err.o \
		   compat_getline.o \
		   compat_progname.o \
		   compat_reallocarray.o \
		   compat_stringlist.o

WWW_MANS	 = apropos.1.html \
		   demandoc.1.html \
		   man.1.html \
		   man.options.1.html \
		   mandoc.1.html \
		   soelim.1.html \
		   man.cgi.3.html \
		   mandoc.3.html \
		   mandoc_escape.3.html \
		   mandoc_headers.3.html \
		   mandoc_html.3.html \
		   mandoc_malloc.3.html \
		   mansearch.3.html \
		   mchars_alloc.3.html \
		   tbl.3.html \
		   man.conf.5.html \
		   mandoc.db.5.html \
		   eqn.7.html \
		   man.7.html \
		   mandoc_char.7.html \
		   mdoc.7.html \
		   roff.7.html \
		   tbl.7.html \
		   catman.8.html \
		   makewhatis.8.html \
		   man.cgi.8.html \
		   mandocd.8.html

WWW_INCS	 = eqn.h.html \
		   html.h.html \
		   man.h.html \
		   manconf.h.html \
		   mandoc.h.html \
		   mandoc_aux.h.html \
		   mandoc_parse.h.html \
		   mansearch.h.html \
		   mdoc.h.html \
		   roff.h.html \
		   tbl.h.html \
		   tbl_int.h.html \
		   tbl_parse.h.html

# === USER CONFIGURATION ===============================================

include Makefile.local

# === DEPENDENCY HANDLING ==============================================

all: mandoc demandoc soelim $(BUILD_TARGETS) Makefile.local

install: base-install $(INSTALL_TARGETS)

www: $(WWW_MANS) $(WWW_INCS)

$(WWW_MANS) $(WWW_INCS): mandoc

.PHONY: base-install cgi-install install www-install
.PHONY: clean distclean depend

include Makefile.depend

# === TARGETS CONTAINING SHELL COMMANDS ================================

distclean: clean
	rm -f Makefile.local config.h config.h.old config.log config.log.old

clean:
	rm -f libmandoc.a $(LIBMANDOC_OBJS) $(COMPAT_OBJS)
	rm -f mandoc $(MAIN_OBJS)
	rm -f man.cgi $(CGI_OBJS)
	rm -f mandocd catman catman.o $(MANDOCD_OBJS)
	rm -f demandoc $(DEMANDOC_OBJS)
	rm -f soelim $(SOELIM_OBJS)
	rm -f $(WWW_MANS) $(WWW_INCS) mandoc*.tar.gz mandoc*.sha256
	rm -rf *.dSYM

base-install: mandoc demandoc soelim
	mkdir -p $(DESTDIR)$(BINDIR)
	mkdir -p $(DESTDIR)$(SBINDIR)
	mkdir -p $(DESTDIR)$(MANDIR)/man1
	mkdir -p $(DESTDIR)$(MANDIR)/man5
	mkdir -p $(DESTDIR)$(MANDIR)/man7
	mkdir -p $(DESTDIR)$(MANDIR)/man8
	$(INSTALL_PROGRAM) mandoc demandoc $(DESTDIR)$(BINDIR)
	$(INSTALL_PROGRAM) soelim $(DESTDIR)$(BINDIR)/$(BINM_SOELIM)
	cd $(DESTDIR)$(BINDIR) && $(LN) mandoc $(BINM_MAN)
	cd $(DESTDIR)$(BINDIR) && $(LN) mandoc $(BINM_APROPOS)
	cd $(DESTDIR)$(BINDIR) && $(LN) mandoc $(BINM_WHATIS)
	cd $(DESTDIR)$(SBINDIR) && \
		$(LN) ${BIN_FROM_SBIN}/mandoc $(BINM_MAKEWHATIS)
	$(INSTALL_MAN) mandoc.1 demandoc.1 $(DESTDIR)$(MANDIR)/man1
	$(INSTALL_MAN) soelim.1 $(DESTDIR)$(MANDIR)/man1/$(BINM_SOELIM).1
	$(INSTALL_MAN) man.1 $(DESTDIR)$(MANDIR)/man1/$(BINM_MAN).1
	$(INSTALL_MAN) apropos.1 $(DESTDIR)$(MANDIR)/man1/$(BINM_APROPOS).1
	cd $(DESTDIR)$(MANDIR)/man1 && $(LN) $(BINM_APROPOS).1 $(BINM_WHATIS).1
	$(INSTALL_MAN) man.conf.5 $(DESTDIR)$(MANDIR)/man5/$(MANM_MANCONF).5
	$(INSTALL_MAN) mandoc.db.5 $(DESTDIR)$(MANDIR)/man5
	$(INSTALL_MAN) man.7 $(DESTDIR)$(MANDIR)/man7/$(MANM_MAN).7
	$(INSTALL_MAN) mdoc.7 $(DESTDIR)$(MANDIR)/man7/$(MANM_MDOC).7
	$(INSTALL_MAN) roff.7 $(DESTDIR)$(MANDIR)/man7/$(MANM_ROFF).7
	$(INSTALL_MAN) eqn.7 $(DESTDIR)$(MANDIR)/man7/$(MANM_EQN).7
	$(INSTALL_MAN) tbl.7 $(DESTDIR)$(MANDIR)/man7/$(MANM_TBL).7
	$(INSTALL_MAN) mandoc_char.7 $(DESTDIR)$(MANDIR)/man7
	$(INSTALL_MAN) makewhatis.8 \
		$(DESTDIR)$(MANDIR)/man8/$(BINM_MAKEWHATIS).8

lib-install: libmandoc.a
	mkdir -p $(DESTDIR)$(LIBDIR)
	mkdir -p $(DESTDIR)$(INCLUDEDIR)
	mkdir -p $(DESTDIR)$(MANDIR)/man3
	$(INSTALL_LIB) libmandoc.a $(DESTDIR)$(LIBDIR)
	$(INSTALL_LIB) eqn.h man.h mandoc.h mandoc_aux.h mandoc_parse.h \
		mdoc.h roff.h tbl.h $(DESTDIR)$(INCLUDEDIR)
	$(INSTALL_MAN) mandoc.3 mandoc_escape.3 mandoc_malloc.3 \
		mansearch.3 mchars_alloc.3 tbl.3 $(DESTDIR)$(MANDIR)/man3

cgi-install: man.cgi
	mkdir -p $(DESTDIR)$(CGIBINDIR)
	mkdir -p $(DESTDIR)$(HTDOCDIR)
	$(INSTALL_PROGRAM) man.cgi $(DESTDIR)$(CGIBINDIR)
	$(INSTALL_DATA) mandoc.css $(DESTDIR)$(HTDOCDIR)

catman-install: mandocd catman
	mkdir -p $(DESTDIR)$(SBINDIR)
	mkdir -p $(DESTDIR)$(MANDIR)/man8
	$(INSTALL_PROGRAM) mandocd $(DESTDIR)$(SBINDIR)
	$(INSTALL_PROGRAM) catman $(DESTDIR)$(SBINDIR)/$(BINM_CATMAN)
	$(INSTALL_MAN) mandocd.8 $(DESTDIR)$(MANDIR)/man8
	$(INSTALL_MAN) catman.8 $(DESTDIR)$(MANDIR)/man8/$(BINM_CATMAN).8

uninstall:
	rm -f $(DESTDIR)$(BINDIR)/mandoc
	rm -f $(DESTDIR)$(BINDIR)/demandoc
	rm -f $(DESTDIR)$(BINDIR)/$(BINM_SOELIM)
	rm -f $(DESTDIR)$(BINDIR)/$(BINM_MAN)
	rm -f $(DESTDIR)$(BINDIR)/$(BINM_APROPOS)
	rm -f $(DESTDIR)$(BINDIR)/$(BINM_WHATIS)
	rm -f $(DESTDIR)$(SBINDIR)/$(BINM_MAKEWHATIS)
	rm -f $(DESTDIR)$(MANDIR)/man1/mandoc.1
	rm -f $(DESTDIR)$(MANDIR)/man1/demandoc.1
	rm -f $(DESTDIR)$(MANDIR)/man1/$(BINM_SOELIM).1
	rm -f $(DESTDIR)$(MANDIR)/man1/$(BINM_MAN).1
	rm -f $(DESTDIR)$(MANDIR)/man1/$(BINM_APROPOS).1
	rm -f $(DESTDIR)$(MANDIR)/man1/$(BINM_WHATIS).1
	rm -f $(DESTDIR)$(MANDIR)/man5/$(MANM_MANCONF).5
	rm -f $(DESTDIR)$(MANDIR)/man5/mandoc.db.5
	rm -f $(DESTDIR)$(MANDIR)/man7/$(MANM_MAN).7
	rm -f $(DESTDIR)$(MANDIR)/man7/$(MANM_MDOC).7
	rm -f $(DESTDIR)$(MANDIR)/man7/$(MANM_ROFF).7
	rm -f $(DESTDIR)$(MANDIR)/man7/$(MANM_EQN).7
	rm -f $(DESTDIR)$(MANDIR)/man7/$(MANM_TBL).7
	rm -f $(DESTDIR)$(MANDIR)/man7/mandoc_char.7
	rm -f $(DESTDIR)$(MANDIR)/man8/$(BINM_MAKEWHATIS).8
	rm -f $(DESTDIR)$(CGIBINDIR)/man.cgi
	rm -f $(DESTDIR)$(HTDOCDIR)/mandoc.css
	rm -f $(DESTDIR)$(SBINDIR)/mandocd

=== regress/eqn/define/Makefile ===
# $OpenBSD: Makefile,v 1.1 2015/01/28 21:10:28 schwarze Exp $

REGRESS_TARGETS	 = font infinite invalid quoted
LINT_TARGETS	 = infinite invalid

.include <bsd.regress.mk>

=== regress/eqn/unary/Makefile ===
# $OpenBSD: Makefile,v 1.1.1.1 2015/01/01 12:53:46 schwarze Exp $

REGRESS_TARGETS	 = bold diacrit sqrt
HTML_TARGETS	 = bold diacrit sqrt

.include <bsd.regress.mk>

=== regress/man/HP/Makefile ===
# $OpenBSD: Makefile,v 1.3 2019/01/06 04:41:15 schwarze Exp $

REGRESS_TARGETS = break literal macrotag manyargs spacing
HTML_TARGETS	= literal

.include <bsd.regress.mk>

=== regress/man/IP/Makefile ===
# $OpenBSD: Makefile,v 1.9 2019/01/06 04:41:15 schwarze Exp $

REGRESS_TARGETS = empty literal longhead manyargs spacing width
LINT_TARGETS	= empty
HTML_TARGETS	= literal

.include <bsd.regress.mk>

=== regress/man/PD/Makefile ===
# $OpenBSD: Makefile,v 1.3 2015/03/20 14:47:20 schwarze Exp $

REGRESS_TARGETS	 = args nextline spacing
LINT_TARGETS	 = args

.include <bsd.regress.mk>

=== regress/man/SH/Makefile ===
# $OpenBSD: Makefile,v 1.6 2019/01/06 04:41:15 schwarze Exp $

REGRESS_TARGETS	= broken broken_eline empty_before longarg noarg paragraph
LINT_TARGETS	= broken broken_eline empty_before noarg
HTML_TARGETS	= paragraph

# groff-1.22.3 defects:
# - .SH without args just before EOF causes two additional blank lines.
# - Empty .SH heads cause additional vertical spacing.
# - If .TP or .IP breaks .SH, the tag becomes bold.
# - If .HP breaks .SH, a line is broken after the next input line.
# - If .RS/RE/nf/fi breaks .SH, the next input line becomes bold.
# - .UR does not break .SH.
# - blank line in .SH next line scope causes blank lines and bogus indent

SKIP_GROFF	= broken broken_eline noarg

.include <bsd.regress.mk>

=== regress/man/SS/Makefile ===
# $OpenBSD: Makefile,v 1.4 2019/01/06 04:41:15 schwarze Exp $

REGRESS_TARGETS	= broken broken_eline longarg noarg paragraph
LINT_TARGETS	= broken broken_eline noarg
HTML_TARGETS	= paragraph

# groff-1.22.3 defects:
# - .SS without args just before EOF causes two additional blank lines.
# - Empty .SS heads cause additional vertical spacing.
# - If .TP or .IP breaks .SS, the tag becomes bold.
# - If .HP breaks .SS, a line is broken after the next input line.
# - If .RS/RE/nf/fi breaks .SS, the next input line becomes bold.
# - .UR does not break .SS.
# - blank line in .SS next-line scope causes a blank line

SKIP_GROFF	= broken broken_eline noarg

.include <bsd.regress.mk>

=== regress/man/TP/Makefile ===
# $OpenBSD: Makefile,v 1.15 2019/01/06 04:41:15 schwarze Exp $

REGRESS_TARGETS	 = badarg broken double eof fill indent literal longhead
REGRESS_TARGETS	+= macrotag manyargs sameline spacing width
LINT_TARGETS	 = broken double eof
HTML_TARGETS	 = literal

# groff-1.22.3 defects:
# - If .TP precedes .RE, the latter does not properly reset indentation.
# - If the last line of the file is .TP, groff does not print a page footer.
# - A blank line in .TP next line scope causes a blank line.

SKIP_GROFF	 = broken eof

.include <bsd.regress.mk>

=== regress/mdoc/At/Makefile ===
# $OpenBSD: Makefile,v 1.2 2014/07/05 12:33:54 schwarze Exp $

REGRESS_TARGETS	= invalid
LINT_TARGETS	= invalid

.include <bsd.regress.mk>

=== regress/mdoc/Bd/Makefile ===
# $OpenBSD: Makefile,v 1.22 2019/01/07 06:51:37 schwarze Exp $

REGRESS_TARGETS	 = beforeNAME blank centered nested nf paragraph spacing
REGRESS_TARGETS	+= badargs empty offset-empty offset-neg
REGRESS_TARGETS	+= break broken unclosed

LINT_TARGETS	 = beforeNAME blank nested badargs break broken unclosed
HTML_TARGETS	 = nf paragraph

SKIP_TMAN	 = beforeNAME centered

# groff-1.22.3 defects:
# - a display breaking another block continues indefinitely
# - negative offsets take no effect, but advance the indention on exit

SKIP_GROFF	 = break offset-neg

# adjustment is disabled in groff for now

SKIP_GROFF	+= centered

# groff handles content before NAME differently

SKIP_GROFF	+= beforeNAME

.include <bsd.regress.mk>

=== regress/mdoc/Bl/Makefile ===
# $OpenBSD: Makefile,v 1.40 2018/12/21 16:58:49 schwarze Exp $

REGRESS_TARGETS  = item inset diag ohang bullet dash enum hang tag
REGRESS_TARGETS += column column_nogroff colNoIt
REGRESS_TARGETS += esc extend nested offset secstart

REGRESS_TARGETS += notype multitype badargs
REGRESS_TARGETS += empty noIt emptyhead emptytag emptyitem multitag
REGRESS_TARGETS += bareIt bareTa unclosed break breakingIt breakingTa broken

UTF8_TARGETS	 = dash

LINT_TARGETS	 = inset diag column column_nogroff notype badargs tag
LINT_TARGETS	+= empty noIt emptyhead emptytag emptyitem
LINT_TARGETS	+= bareIt bareTa break breakingIt broken

# groff-mandoc differences:
# - groff allows enclosures to span Ta, mandoc does not

SKIP_GROFF ?= breakingTa

# groff-1.22.3 defects:
# - column list items with no args but multiple lines cause bogus breaks
# - in column lists, the tab macro cannot be a line macro
# - lists with missing or late type ruin indentation
# - empty lists ruin indentation and sometimes cause empty lines
# - breaking lists continue indefinitely
# - breaking items sometimes ruin indentation, sometimes abort processing
# - breaking a list aborts processing
# - empty -tag item heads lose the blank line and the indentation

SKIP_GROFF += column_nogroff notype empty emptytag break breakingIt broken

SKIP_TMAN ?= column colNoIt multitype multitag bareTa break breakingTa broken

# Fixing the indentation in long .IP and .TP tags in -man -Tascii
# caused a minor regression in -Tman that is not trivial to fix,
# so disable the related test for now.

SKIP_TMAN += tag

# Empty heads are still mishandled by -Tman.

SKIP_TMAN += column_nogroff emptyhead emptytag

# mandoc -T markdown still has issues with badly nested lists

SKIP_MARKDOWN ?= break

.include <bsd.regress.mk>

=== debian/changelog ===
mdocml (1.14.5-1) unstable; urgency=medium

  [Bdale Garbee]
  * merge proposed NMU content with work on new upstream version 

  [Michael Stapelberg]
  * New upstream version 1.14.5
  * cherry-pick assertion fix from discuss@mandoc.bsd.lv mailing list

  [Francisco Vilmar Cardoso Ruviaro]
  * Add debian/patches/fix-ftbfs-with-gcc-10.patch,
    thanks to Ivo De Decker <ivodd@debian.org>. (Closes: #957527)
  * Update debian/rules to fix FTCBFS.

 -- Bdale Garbee <bdale@gag.com>  Tue, 16 Feb 2021 14:09:53 -0700

## mdocml 1.14.6

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
-# $Id: Makefile,v 1.530 2019/03/06 16:08:41 schwarze Exp $
+# $Id: Makefile,v 1.540 2021/09/21 11:04:40 schwarze Exp $
 #
+# Copyright (c) 2011, 2013-2021 Ingo Schwarze <schwarze@openbsd.org>
 # Copyright (c) 2010, 2011, 2012 Kristaps Dzonsons <kristaps@bsd.lv>
-# Copyright (c) 2011, 2013-2019 Ingo Schwarze <schwarze@openbsd.org>
 #
 # Permission to use, copy, modify, and distribute this software for any
 # purpose with or without fee is hereby granted, provided that the above
@@ -15,11 +15,12 @@
 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
-VERSION = 1.14.5
+VERSION = 1.14.6
 
 # === LIST OF FILES ====================================================
 
-TESTSRCS	 = test-be32toh.c \
+TESTSRCS	 = test-attribute.c \
+		   test-be32toh.c \
 		   test-cmsg.c \
 		   test-dirent-namlen.c \
 		   test-EFTYPE.c \
@@ -29,6 +30,7 @@
 		   test-getsubopt.c \
 		   test-isblank.c \
 		   test-mkdtemp.c \
+		   test-mkstemps.c \
 		   test-nanosleep.c \
 		   test-noop.c \
 		   test-ntohl.c \
@@ -65,6 +67,7 @@
 		   compat_getsubopt.c \
 		   compat_isblank.c \
 		   compat_mkdtemp.c \
+		   compat_mkstemps.c \
 		   compat_ohash.c \
 		   compat_progname.c \
 		   compat_reallocarray.c \
@@ -134,6 +137,7 @@
 		   term_ascii.c \
 		   term_ps.c \
 		   term_tab.c \
+		   term_tag.c \
 		   tree.c
 
 DISTFILES	 = INSTALL \
@@ -209,6 +213,7 @@
 		   tbl_int.h \
 		   tbl_parse.h \
 		   term.h \
+		   term_tag.h \
 		   $(SRCS) \
 		   $(TESTSRCS)
 
@@ -245,19 +250,22 @@
 		   mandoc_xr.o \
 		   msec.o \
 		   preconv.o \
-		   read.o
-
-COMPAT_OBJS	 = compat_err.o \
+		   read.o \
+		   tag.o
+
+ALL_COBJS	 = compat_err.o \
 		   compat_fts.o \
 		   compat_getline.o \
 		   compat_getsubopt.o \
 		   compat_isblank.o \
 		   compat_mkdtemp.o \
+		   compat_mkstemps.o \
 		   compat_ohash.o \
 		   compat_progname.o \
 		   compat_reallocarray.o \
 		   compat_recallocarray.o \
 		   compat_strcasestr.o \
+		   compat_stringlist.o \
 		   compat_strlcat.o \
 		   compat_strlcpy.o \
 		   compat_strndup.o \
@@ -280,6 +288,7 @@
 		   term_ascii.o \
 		   term_ps.o \
 		   term_tab.o \
+		   term_tag.o \
 		   tbl_term.o
 
 DBM_OBJS	 = dbm.o \
@@ -302,7 +311,6 @@
 		   mdoc_man.o \
 		   mdoc_markdown.o \
 		   out.o \
-		   tag.o \
 		   tree.o
 
 CGI_OBJS	 = $(MANDOC_HTML_OBJS) \
@@ -313,17 +321,9 @@
 MANDOCD_OBJS	 = $(MANDOC_HTML_OBJS) \
 		   $(MANDOC_TERM_OBJS) \
 		   mandocd.o \
-		   out.o \
-		   tag.o
+		   out.o
 
 DEMANDOC_OBJS	 = demandoc.o
-
-SOELIM_OBJS	 = soelim.o \
-		   compat_err.o \
-		   compat_getline.o \
-		   compat_progname.o \
-		   compat_reallocarray.o \
-		   compat_stringlist.o
 
 WWW_MANS	 = apropos.1.html \
 		   demandoc.1.html \
@@ -373,7 +373,7 @@
 
 # === DEPENDENCY HANDLING ==============================================
 
-all: mandoc demandoc soelim $(BUILD_TARGETS) Makefile.local
+all: mandoc man demandoc soelim $(BUILD_TARGETS) Makefile.local
 
 install: base-install $(INSTALL_TARGETS)
 
@@ -392,13 +392,14 @@
 	rm -f Makefile.local config.h config.h.old config.log config.log.old
 
 clean:
-	rm -f libmandoc.a $(LIBMANDOC_OBJS) $(COMPAT_OBJS)
-	rm -f mandoc $(MAIN_OBJS)
+	rm -f libmandoc.a $(LIBMANDOC_OBJS) $(ALL_COBJS)
+	rm -f mandoc man $(MAIN_OBJS)
 	rm -f man.cgi $(CGI_OBJS)
 	rm -f mandocd catman catman.o $(MANDOCD_OBJS)
 	rm -f demandoc $(DEMANDOC_OBJS)
-	rm -f soelim $(SOELIM_OBJS)
+	rm -f soelim soelim.o
 	rm -f $(WWW_MANS) $(WWW_INCS) mandoc*.tar.gz mandoc*.sha256
+	rm -f Makefile.tmp1 Makefile.tmp2
 	rm -rf *.dSYM
 
 base-install: mandoc demandoc soelim
@@ -479,5 +480,3 @@
 	rm -f $(DESTDIR)$(MANDIR)/man7/mandoc_char.7
 	rm -f $(DESTDIR)$(MANDIR)/man8/$(BINM_MAKEWHATIS).8
 	rm -f $(DESTDIR)$(CGIBINDIR)/man.cgi
-	rm -f $(DESTDIR)$(HTDOCDIR)/mandoc.css
-	rm -f $(DESTDIR)$(SBINDIR)/mandocd

=== regress/char/Makefile ===
# $OpenBSD: Makefile,v 1.9 2014/06/20 18:27:51 schwarze Exp $

SUBDIR = accent bar hyphen space unicode N

.include "../Makefile.sub"
.include <bsd.subdir.mk>

=== regress/mdoc/Makefile ===
# $OpenBSD: Makefile,v 1.33 2020/03/13 00:31:05 schwarze Exp $

SUBDIR  = Ad An Ap Aq Ar At Bd Bf Bk Bl Brq Bx Cd Cm
SUBDIR += D1 Db Dd Dl Dq Dt Dv Em Eo Er Ev Ex Fd Fl Fo Ft Ic In Lb Li Lk
SUBDIR += Ms Mt Nd Nm No Ns Oo Op Os Ox Pa Pf Pp Qq Rs Rv
SUBDIR += Sh Sm Sq St Sx Sy Tg Tn Ud Ux Va Vt Xr blank break

.include "../Makefile.sub"
.include <bsd.subdir.mk>

=== regress/char/accent/Makefile ===
# $OpenBSD: Makefile,v 1.1 2014/03/08 18:00:59 schwarze Exp $

REGRESS_TARGETS = nocombine utf8only combine
SKIP_ASCII = utf8only combine
UTF8_TARGETS = nocombine utf8only combine
LINT_TARGETS = nocombine

.include <bsd.regress.mk>

=== regress/eqn/delim/Makefile ===
# $OpenBSD: Makefile,v 1.3 2020/01/08 12:09:14 schwarze Exp $

REGRESS_TARGETS	 = basic
UTF8_TARGETS	 = basic
GOPTS		 = -e
SKIP_GROFF	 =

.include <bsd.regress.mk>

=== regress/man/BI/Makefile ===
# $OpenBSD: Makefile,v 1.3 2015/04/06 22:06:06 schwarze Exp $

REGRESS_TARGETS	 = emptyargs literal

.include <bsd.regress.mk>

=== regress/man/EX/Makefile ===
# $OpenBSD: Makefile,v 1.1 2012/06/02 20:07:09 schwarze Exp $

REGRESS_TARGETS=spacing nested args

.include <bsd.regress.mk>

=== regress/man/OP/Makefile ===
# $OpenBSD: Makefile,v 1.1 2015/02/06 11:54:03 schwarze Exp $

REGRESS_TARGETS	 = args
LINT_TARGETS	 = args

.include <bsd.regress.mk>

=== regress/man/RS/Makefile ===
# $OpenBSD: Makefile,v 1.14 2019/01/06 04:41:15 schwarze Exp $

REGRESS_TARGETS	 = an-margin breaking broken empty literal lonelyRE
REGRESS_TARGETS	+= nested noRE nowidth paragraph REarg width
LINT_TARGETS	 = empty lonelyRE noRE REarg
HTML_TARGETS	 = literal paragraph

.include <bsd.regress.mk>

=== regress/man/SH/Makefile ===
--- 
+++ 
@@ -1,8 +1,9 @@
-# $OpenBSD: Makefile,v 1.6 2019/01/06 04:41:15 schwarze Exp $
+# $OpenBSD: Makefile,v 1.8 2020/04/04 20:23:07 schwarze Exp $
 
-REGRESS_TARGETS	= broken broken_eline empty_before longarg noarg paragraph
+REGRESS_TARGETS	= broken broken_eline empty_before longarg noarg paragraph vert
 LINT_TARGETS	= broken broken_eline empty_before noarg
 HTML_TARGETS	= paragraph
+TAG_TARGETS	= paragraph
 
 # groff-1.22.3 defects:
 # - .SH without args just before EOF causes two additional blank lines.

=== regress/man/SS/Makefile ===
--- 
+++ 
@@ -1,8 +1,9 @@
-# $OpenBSD: Makefile,v 1.4 2019/01/06 04:41:15 schwarze Exp $
+# $OpenBSD: Makefile,v 1.6 2020/04/04 20:23:07 schwarze Exp $
 
-REGRESS_TARGETS	= broken broken_eline longarg noarg paragraph
+REGRESS_TARGETS	= broken broken_eline longarg noarg paragraph vert
 LINT_TARGETS	= broken broken_eline noarg
 HTML_TARGETS	= paragraph
+TAG_TARGETS	= paragraph
 
 # groff-1.22.3 defects:
 # - .SS without args just before EOF causes two additional blank lines.

=== regress/man/TP/Makefile ===
--- 
+++ 
@@ -1,9 +1,10 @@
-# $OpenBSD: Makefile,v 1.15 2019/01/06 04:41:15 schwarze Exp $
+# $OpenBSD: Makefile,v 1.17 2020/03/13 00:31:05 schwarze Exp $
 
 REGRESS_TARGETS	 = badarg broken double eof fill indent literal longhead
-REGRESS_TARGETS	+= macrotag manyargs sameline spacing width
+REGRESS_TARGETS	+= macrotag manyargs sameline spacing tag vert width
+TAG_TARGETS	 = tag
 LINT_TARGETS	 = broken double eof
-HTML_TARGETS	 = literal
+HTML_TARGETS	 = literal tag vert
 
 # groff-1.22.3 defects:
 # - If .TP precedes .RE, the latter does not properly reset indentation.

=== debian/changelog ===
mdocml (1.14.6-4) unstable; urgency=low

  * d/control: use my @debian.org email address
  * d/copyright: add debian/* stanza
  * d/README.source: document packaging workflow

 -- Andrea Pappacoda <tachi@debian.org>  Wed, 16 Apr 2025 11:10:00 +0200

mdocml (1.14.6-3) unstable; urgency=medium

  * test-recvmsg.c: pass non-null to recvmsg.
    Fixes build failure on Hurd (Closes: #1086138)

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 05 Dec 2024 00:08:33 +0100

mdocml (1.14.6-2) unstable; urgency=low

  * d/control: set myself as the Maintainer.
    I'm taking over maintenance of the mdocml package after talking with
    Michael Stapelberg, the former maintainer. Thanks for all your work,
    Michael!
  * d/rules: write configure.local during build instead of using patch.
    Apart from being easier to handle, this allows populating fields
    dynamically depending on the build environment.
  * d/rules: run distclean and clean test files (Closes: #1048837)
  * d/rules: install manuals in mdoc format (Closes: #1022809)
  * d/control: mark mandoc Multi-Arch: foreign (Closes: #951560)
  * d/rules: use "pager" as the default pager (Closes: #994024)
  * d/upstream: add upstream metadata
  * Build and ship libmandoc library in libmandoc-dev package (Closes: #1082765)

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 26 Sep 2024 22:16:52 +0200

mdocml (1.14.6-1) unstable; urgency=medium

  * New upstream version 1.14.6
  * drop patches merged upstream

 -- Michael Stapelberg <stapelberg@debian.org>  Sat, 25 Sep 2021 13:52:31 +0000

=== debian/control ===
Source: mdocml
Section: doc
Priority: optional
Maintainer: Andrea Pappacoda <tachi@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dpkg-build-api (= 1),
 zlib1g-dev,
Standards-Version: 4.7.2
Homepage: https://mandoc.bsd.lv
Vcs-Git: https://salsa.debian.org/debian/mdocml.git
Vcs-Browser: https://salsa.debian.org/debian/mdocml
X-Style: black

Package: mandoc
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: BSD manpage compiler toolset
 mandoc is a suite of tools compiling mdoc, the roff macro language of choice
 for BSD manual pages, and man, the predominant historical language for UNIX
 manuals. It is small, ISO C, ISC-licensed, and quite fast. The main component
 of the toolset is the mandoc utility program, based on the libmandoc
 validating compiler, to format output for UNIX terminals (with support for
 wide-character locales), XHTML, HTML, PostScript, and PDF.

Package: libmandoc-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
Description: BSD manpage compiler toolset - library
 mandoc is a suite of tools compiling mdoc, the roff macro language of choice
 for BSD manual pages, and man, the predominant historical language for UNIX
 manuals. It is small, ISO C, ISC-licensed, and quite fast. The main component
 of the toolset is the mandoc utility program, based on the libmandoc
 validating compiler, to format output for UNIX terminals (with support for
 wide-character locales), XHTML, HTML, PostScript, and PDF.
 .
 This package contains the libmandoc static library, which can be used to
 embed mandoc in other programs.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/buildtools.mk
include /usr/share/dpkg/vendor.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

execute_before_dh_auto_configure:
	printf '%s\n' \
		'OSNAME="$(DEB_VENDOR)"' \
		'AR="$(AR)"' \
		'CC="$(CC)"' \
		'CFLAGS="$(CFLAGS)"' \
		'CPPFLAGS="$(CPPFLAGS)"' \
		'LDFLAGS="$(LDFLAGS)"' \
		'BUILD_CATMAN=1' \
		'BUILD_DB=0' \
		'INSTALL_LIBMANDOC=1' \
		'HAVE_WCHAR=1' \
		'PREFIX=/usr' \
		'LIBDIR="$${PREFIX}/lib/$(DEB_HOST_MULTIARCH)"' \
		'MANDIR="$${PREFIX}/share/man"' \
		'EXAMPLEDIR="$${PREFIX}/share/doc/mandoc"' \
		'BINM_APROPOS=mapropos' \
		'BINM_CATMAN=mcatman' \
		'BINM_MAN=mman' \
		'BINM_SOELIM=msoelim' \
		'BINM_WHATIS=mwhatis' \
		'BINM_PAGER=pager' \
		'MANM_MAN="mandoc_man"' \
		'MANM_MDOC="mandoc_mdoc"' \
		'MANM_ROFF="mandoc_roff"' \
		'MANM_EQN="mandoc_eqn"' \
		'MANM_TBL="mandoc_tbl"' \
		'INSTALL_PROGRAM="$${INSTALL} -m 0755"' \
		'INSTALL_LIB="$${INSTALL} -m 0644"' \
		'INSTALL_MAN="$${INSTALL} -m 0644"' \
		'INSTALL_DATA="$${INSTALL} -m 0644"' \
		'LN="ln -sf"' \
		> configure.local

override_dh_auto_clean:
	$(RM) configure.local
	[ ! -f Makefile.local ] || $(MAKE) distclean

override_dh_installchangelogs:
	dh_installchangelogs NEWS

# Needed to install mandoc.db into the correct directory
override_dh_installman:
	dh_installman --language=C

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	(cd regress && ./regress.pl . all clean)
endif
